# Class MarkupEntity`Abstract`

Super class for markup entities in the markup API.

#### Hierarchy (View Summary)

- MarkupEntityBase
  - MarkupEntity
    - MarkupArea
    - MarkupLine
    - MarkupText
    - MarkupArrow
    - MarkupCircle

##### Index

### Properties

id
properties

### Accessors

isEnabled
sheet

### Methods

clone
copyTo
isEqual
markAsDeleted
markAsUpdated
onAdded
onDelete
onUpdate

## Properties

### `Readonly` id

id: string

Inherited from MarkupEntityBase.id

### `Readonly` properties

properties: Map<string, MarkupProperty> = ...

Inherited from MarkupEntityBase.properties

## Accessors

### isEnabled

- get isEnabled(): boolean

  Returns `true` if the entity and the sheet it belongs to are both enabled, otherwise `false`.

  #### Returns boolean

  Overrides MarkupEntityBase.isEnabled

- set isEnabled(b: boolean): void

  Sets if entity is enabled

  #### Parameters

  - b: boolean

  #### Returns void

  Overrides MarkupEntityBase.isEnabled

### sheet

- get sheet(): MarkupSheet2D

  Returns the markup sheet that the entity is attached to

  #### Returns MarkupSheet2D

## Methods

### `Abstract` clone

- clone(): MarkupEntityBase

  Makes a deep copy of this entity

  #### Returns MarkupEntityBase

  Overrides MarkupEntityBase.clone

### `Abstract` copyTo

- copyTo(sheet: MarkupSheet2D): MarkupEntity

  Copy the entity to another markup sheet.

  #### Parameters

  - sheet: MarkupSheet2D

    Markup sheet to copy the entity to.

  #### Returns MarkupEntity

  The new markup entity.

### `Abstract` isEqual

- isEqual(o: MarkupEntityBase): boolean

  Compares if this entity is equal to another entity

  #### Parameters

  - o: MarkupEntityBase

  #### Returns boolean

  Overrides MarkupEntityBase.isEqual

### markAsDeleted

- markAsDeleted(): boolean

  Marks the entity as deleted in the MarkupSheet2D.

  #### Returns boolean

  `true` if object was deleted. Otherwise `false`.

  Overrides MarkupEntityBase.markAsDeleted

### markAsUpdated

- markAsUpdated(): boolean

  Sets the entity as updated in the layer API.

  #### Returns boolean

  `true` if object did exist, otherwise `false`

  Overrides MarkupEntityBase.markAsUpdated

### onAdded

- onAdded(o: MergableObjectEventArgs<MarkupEntity>): void

  Called when this entity is added

  #### Parameters

  - o: MergableObjectEventArgs<MarkupEntity>

  #### Returns void

  Overrides MarkupEntityBase.onAdded

### onDelete

- onDelete(o: MergableObjectEventArgs<MarkupEntity>): void

  Called when this entity is deleted

  #### Parameters

  - o: MergableObjectEventArgs<MarkupEntity>

  #### Returns void

  Overrides MarkupEntityBase.onDelete

### onUpdate

- onUpdate(o: MergableObjectEventArgs<MarkupEntity>): void

  Called when this entity is updated

  #### Parameters

  - o: MergableObjectEventArgs<MarkupEntity>

  #### Returns void

  Overrides MarkupEntityBase.onUpdate